#include "LCD12864.h"

//********************************************************************
//LCD12864  æ źż
//********************************************************************
void LCD12864_WaitIdle()

{
	unsigned char i;
	LCD12864_DA_PORT = 0xff;
	LCD12864_RS_PORT = 0;
	LCD12864_RW_PORT = 1;
	LCD12864_E_PORT = 1;
	while((LCD12864_DA_PORT&0x80)==1); /*ȴBF Ϊ1*/
	LCD12864_E_PORT = 0;
	for(i=0;i<5;i++);
}


//********************************************************************
//æźд	com_da Ϊд
//********************************************************************
void LCD12864_COM_Write( unsigned char com_da)	
{
	LCD12864_WaitIdle();
	LCD12864_RS_PORT = 0;
	LCD12864_RW_PORT = 0;
	LCD12864_DA_PORT = com_da;
	LCD12864_E_PORT = 1;
	_nop_();
	_nop_();	
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	LCD12864_E_PORT = 0;	
}

//********************************************************************
//æźд		com_da Ϊд
//********************************************************************
void LCD12864_NoWaitIdle_COM_Write(unsigned char com_da)	
{
	LCD12864_RS_PORT = 0;
	LCD12864_RW_PORT = 0;
	LCD12864_DA_PORT = com_da;
	LCD12864_E_PORT = 1;
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	LCD12864_E_PORT = 0;	
}

//********************************************************************
//д		da  Ϊд8λ
//********************************************************************
void LCD12864_Data_Write(unsigned char da)

{
	LCD12864_WaitIdle(); /*æź*/
	LCD12864_RS_PORT = 1;
	LCD12864_RW_PORT = 0;
	LCD12864_DA_PORT = da;
	LCD12864_E_PORT = 1;
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	LCD12864_E_PORT = 0;	
}


//*************************************************************************************
//дַ
//*************************************************************************************
void LCD12864_write_word(unsigned char *s)
{
	while(*s>0)
	{
		LCD12864_Data_Write(*s);
		s++;
	}
}

//********************************************************************
//1MSΪλʱ򣬲׼ȷ
//********************************************************************
void lcd_delay_ms(unsigned char x)
{
    unsigned char j;
    while(x--){
        for(j=0;j<125;j++)
            {;}
        }   
}


//********************************************************************
//LCD12864ʼ
//********************************************************************
void LCD12864_Reset()
{
	lcd_delay_ms(100); /*ʵʱLCDԶλ*/
	LCD12864_NoWaitIdle_COM_Write(0x30); /*ʹ8λͨѶ*/
	lcd_delay_ms(10);
	LCD12864_NoWaitIdle_COM_Write(0x30); /*ʹ8λͨѶ*/
	lcd_delay_ms(10);
	LCD12864_NoWaitIdle_COM_Write(0x0c); /*ʾ*/
	lcd_delay_ms(10);
	LCD12864_NoWaitIdle_COM_Write(0x01); /*ʾ*/
	lcd_delay_ms(30);
	LCD12864_NoWaitIdle_COM_Write(0x06); /*DDRAMĵַAC1*/
	lcd_delay_ms(30);	
}


//void LCD12864_PHOTO_SET()
//{
//	LCD12864_COM_Write(0x36);
//	lcd_delay_ms(10);
//	LCD12864_COM_Write(0x36);
//	lcd_delay_ms(10);
//}
//
void LCD12864_HAIZI_SET()
{
	LCD12864_COM_Write(0x30);
	lcd_delay_ms(10);
	LCD12864_COM_Write(0x30);
	lcd_delay_ms(10);
}
//
//
//void LCD12864_HAIZI_WRITE(unsigned char xpos,unsigned char ypos,unsigned char daH,unsigned char daL)
////ST7920 ַд
////˵: 	xpos дXλ
////ypos дYλ
////daH дĺֵĸ߰λ daLдĺֵĵͰλ
//{
//	unsigned char xy_pos;
//	if((xpos>=8)||(ypos>=4) ) return; /*XλóʾΧ˳*/
//	if(ypos==0)         xy_pos = 0x80 + xpos;
//	else if(ypos==1) xy_pos = 0x90 + xpos; /*תַ*/
//	else if(ypos==2) xy_pos = 0x88 + xpos;
//	else if(ypos==3) xy_pos = 0x98 + xpos;
//	LCD12864_COM_Write(xy_pos); /*дַ*/
//	lcd_delay_ms(1);
//	LCD12864_Data_Write(daH); /*д߰λ*/
//	lcd_delay_ms(1);	
//	LCD12864_Data_Write(daL); /*дͰλ*/	
//	lcd_delay_ms(1);
//}
//
//
//void LCD12864_PHOTO_WRITE(unsigned char *img)
//{
//	unsigned char x,y,i,j;
//	unsigned int k=0;
//	y=0x80; /*ʼ ͼ Yַ*/
//	x=0x80; /*ʼ ͼ Xַ*/
//	for(i=0;i<32;i++){  /*дϰ벿*/
//		LCD12864_COM_Write(y);
//		LCD12864_COM_Write(x);
//		for(j=0;j<16;j++){
//			LCD12864_Data_Write(img[k]);
//			k++;
//			}
//		y++;
//		}
//	
//	y=0x80; /*ʼ ͼ Yַ*/
//	x=0x88; /*ʼ ͼ Xַ*/
//	for(i=0;i<32;i++){  /*д°벿*/
//		LCD12864_COM_Write(y);
//		LCD12864_COM_Write(x);
//		for(j=0;j<16;j++){
//			LCD12864_Data_Write(img[k]);
//			k++;
//			}
//		y++;
//		}
//	
//}